/********************************** (C) COPYRIGHT *******************************
 * File Name          : Main.c
 * Author             : WCH
 * Version            : V1.0
 * Date               : 2020/08/06
 * Description        : CH573 USB IAP: FLASH (rx) :
 *******************************************************************************/

#include "CH57x_common.h"
#include "iap.h"

iap_cmd1 iap_cmd;
__attribute__((aligned(8)))            UINT8 block_buf[256];
#define DevEP0SIZE	8
// 豸
const UINT8 MyDevDescr[] = { 0x12, 0x01, 0x10, 0x01, 0xFF, 0x80, 0x55, DevEP0SIZE, 0x48, 0x43, 0xe0, 0x55,  	// IDͲƷID
                             0x00, 0x01, 0x00, 0x00, 0x00, 0x01, };
// 
const UINT8 MyCfgDescr[] = { 0x09, 0x02, 0x20, 0x00, 0x01, 0x01, 0x00, 0x80, 0x32, 0x09, 0x04, 0x00, 0x00, 0x02, 0xFF,
                             0x80, 0x55, 0x00, 0x07, 0x05, 0x82, 0x02, 0x40, 0x00, 0x00, 0x07, 0x05, 0x02, 0x02, 0x40,
                             0x00, 0x00 };
// 
const UINT8 MyLangDescr[] = { 0x04, 0x03, 0x09, 0x04 };
// Ϣ
const UINT8 MyManuInfo[] = { 0x0E, 0x03, 'w', 0, 'c', 0, 'h', 0, '.', 0, 'c', 0, 'n', 0 };
// ƷϢ
const UINT8 MyProdInfo[] = { 0x0C, 0x03, 'C', 0, 'H', 0, '5', 0, '7', 0, 'x', 0 };

/**********************************************************/
UINT8 DevConfig;
UINT8 SetupReqCode;
UINT16 SetupReqLen;
const UINT8 *pDescr;

/******** ûԶ˵RAM ****************************************/
__attribute__((aligned(4)))                    UINT8 EP0_Databuf[64 + 64 + 64];    //ep0(64)+ep4_out(64)+ep4_in(64)
__attribute__((aligned(4)))                    UINT8 EP1_Databuf[64 + 64];    //ep1_out(64)+ep1_in(64)
__attribute__((aligned(4)))                    UINT8 EP2_Databuf[64 + 64];    //ep2_out(64)+ep2_in(64)
__attribute__((aligned(4)))                    UINT8 EP3_Databuf[64 + 64];    //ep3_out(64)+ep3_in(64)

__attribute__((aligned(4)))                    UINT8 buf_write[256 + 64];
volatile UINT16 buf_write_ptr = 0;
volatile UINT32 flash_write_ptr = 0;
UINT32 tcnt;
void USB_DevTransProcess( void )
{
  UINT8 len, chtype;
  UINT8 intflag, errflag = 0;

  intflag = R8_USB_INT_FG;
  if ( intflag & RB_UIF_TRANSFER )
  {
    tcnt = 0;
    if ( intflag & RB_U_IS_NAK )
    {
    }
    else
    {
      switch ( R8_USB_INT_ST & ( MASK_UIS_TOKEN | MASK_UIS_ENDP ) )
      // ƺͶ˵
      {
        case UIS_TOKEN_OUT | 2 :
        {
          if ( R8_USB_INT_ST & RB_UIS_TOG_OK )
          {                       // ͬݰ
            len = R8_USB_RX_LEN;
            memcpy( iap_cmd.other.buf, pEP2_OUT_DataBuf, len );
            DevEP2_OUT_Deal( len );
          }
        }
          break;

        case UIS_TOKEN_IN | 2 :
          R8_UEP2_CTRL = ( R8_UEP2_CTRL & ~MASK_UEP_T_RES ) | UEP_T_RES_NAK;
          break;
        case UIS_TOKEN_IN | 1 :
          R8_UEP1_CTRL = ( R8_UEP1_CTRL & ~MASK_UEP_T_RES ) | UEP_T_RES_NAK;
          break;

        case UIS_TOKEN_IN :
        {
          switch ( SetupReqCode )
          {
            case USB_GET_DESCRIPTOR :
              len = SetupReqLen >= DevEP0SIZE ?
                  DevEP0SIZE : SetupReqLen;    // δ䳤
              memcpy( pEP0_DataBuf, pDescr, len ); /* ϴ */
              SetupReqLen -= len;
              pDescr += len;
              R8_UEP0_T_LEN = len;
              R8_UEP0_CTRL ^= RB_UEP_T_TOG;                             // ת
              break;
            case USB_SET_ADDRESS :
              R8_USB_DEV_AD = ( R8_USB_DEV_AD & RB_UDA_GP_BIT ) | SetupReqLen;
              R8_UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
              break;
            default :
              R8_UEP0_T_LEN = 0;                                      // ״̬׶жϻǿϴ0ݰƴ
              R8_UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
              break;
          }
        }
          break;

        case UIS_TOKEN_OUT :
          //len = R8_USB_RX_LEN;
          R8_UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
          break;
        default :
          break;
      }
      R8_USB_INT_FG = RB_UIF_TRANSFER;

    }
    if ( R8_USB_INT_ST & RB_UIS_SETUP_ACT )                  // Setup
    {
      R8_UEP0_CTRL = RB_UEP_R_TOG | RB_UEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_NAK;
      SetupReqLen = pSetupReqPak->wLength;
      SetupReqCode = pSetupReqPak->bRequest;
      chtype = pSetupReqPak->bRequestType;

      len = 0;
      errflag = 0;
      if ( ( pSetupReqPak->bRequestType & USB_REQ_TYP_MASK ) != USB_REQ_TYP_STANDARD )
      {
        errflag = 0xFF; /* Ǳ׼ */
      }
      else /* ׼ */
      {
        switch ( SetupReqCode )
        {
          case USB_GET_DESCRIPTOR :
          {
            switch ( ( ( pSetupReqPak->wValue ) >> 8 ) )
            {
              case USB_DESCR_TYP_DEVICE :
              {
                pDescr = MyDevDescr;
                len = MyDevDescr[0];
              }
                break;

              case USB_DESCR_TYP_CONFIG :
              {
                pDescr = MyCfgDescr;
                len = MyCfgDescr[2];
              }
                break;

              case USB_DESCR_TYP_STRING :
              {
                switch ( ( pSetupReqPak->wValue ) & 0xff )
                {
                  case 1 :
                    pDescr = MyManuInfo;
                    len = MyManuInfo[0];
                    break;
                  case 2 :
                    pDescr = MyProdInfo;
                    len = MyProdInfo[0];
                    break;
                  case 0 :
                    pDescr = MyLangDescr;
                    len = MyLangDescr[0];
                    break;
                  default :
                    errflag = 0xFF;                               // ֵַ֧
                    break;
                }
              }
                break;

              default :
                errflag = 0xff;
                break;
            }
            if ( SetupReqLen > len )
              SetupReqLen = len;      //ʵϴܳ
            len = ( SetupReqLen >= DevEP0SIZE ) ?
                DevEP0SIZE : SetupReqLen;
            memcpy( pEP0_DataBuf, pDescr, len );
            pDescr += len;
          }
            break;

          case USB_SET_ADDRESS :
            SetupReqLen = ( pSetupReqPak->wValue ) & 0xff;
            break;

          case USB_GET_CONFIGURATION :
            pEP0_DataBuf[0] = DevConfig;
            if ( SetupReqLen > 1 )
              SetupReqLen = 1;
            break;

          case USB_SET_CONFIGURATION :
            DevConfig = ( pSetupReqPak->wValue ) & 0xff;
            break;

          case USB_CLEAR_FEATURE :
          {
            if ( ( pSetupReqPak->bRequestType & USB_REQ_RECIP_MASK ) == USB_REQ_RECIP_ENDP )    // ˵
            {
              switch ( ( pSetupReqPak->wIndex ) & 0xff )
              {
                case 0x82 :
                  R8_UEP2_CTRL = ( R8_UEP2_CTRL & ~( RB_UEP_T_TOG | MASK_UEP_T_RES ) ) | UEP_T_RES_NAK;
                  break;
                case 0x02 :
                  R8_UEP2_CTRL = ( R8_UEP2_CTRL & ~( RB_UEP_R_TOG | MASK_UEP_R_RES ) ) | UEP_R_RES_ACK;
                  break;
                case 0x81 :
                  R8_UEP1_CTRL = ( R8_UEP1_CTRL & ~( RB_UEP_T_TOG | MASK_UEP_T_RES ) ) | UEP_T_RES_NAK;
                  break;
                case 0x01 :
                  R8_UEP1_CTRL = ( R8_UEP1_CTRL & ~( RB_UEP_R_TOG | MASK_UEP_R_RES ) ) | UEP_R_RES_ACK;
                  break;
                default :
                  errflag = 0xFF;                                 // ֵ֧Ķ˵
                  break;
              }
            }
            else
              errflag = 0xFF;
          }
            break;

          case USB_GET_INTERFACE :
            pEP0_DataBuf[0] = 0x00;
            if ( SetupReqLen > 1 )
              SetupReqLen = 1;
            break;

          case USB_GET_STATUS :
            pEP0_DataBuf[0] = 0x00;
            pEP0_DataBuf[1] = 0x00;
            if ( SetupReqLen > 2 )
              SetupReqLen = 2;
            break;

          default :
            errflag = 0xff;
            break;
        }
      }
      if ( errflag == 0xff )        // ֧
      {
//                  SetupReqCode = 0xFF;
        R8_UEP0_CTRL = RB_UEP_R_TOG | RB_UEP_T_TOG | UEP_R_RES_STALL | UEP_T_RES_STALL;    // STALL
      }
      else
      {
        if ( chtype & 0x80 )     // ϴ
        {
          len = ( SetupReqLen > DevEP0SIZE ) ?
              DevEP0SIZE : SetupReqLen;
          SetupReqLen -= len;
        }
        else
          len = 0;        // ´
        R8_UEP0_T_LEN = len;
        R8_UEP0_CTRL = RB_UEP_R_TOG | RB_UEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK;    // ĬݰDATA1
      }

      R8_USB_INT_FG = RB_UIF_TRANSFER;
    }
  }
  else if ( intflag & RB_UIF_BUS_RST )
  {
    R8_USB_DEV_AD = 0;
    R8_UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
    R8_UEP1_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK | RB_UEP_AUTO_TOG;
    R8_UEP2_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK | RB_UEP_AUTO_TOG;
    R8_UEP3_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK | RB_UEP_AUTO_TOG;
    R8_USB_INT_FG = RB_UIF_BUS_RST;
  }
  else if ( intflag & RB_UIF_SUSPEND )
  {
    // 
    R8_USB_INT_FG = RB_UIF_SUSPEND;
  }
  else
  {
    R8_USB_INT_FG = intflag;
  }
}

int main()
{
  UINT16 j = 0;
  UINT8 i;


  unsigned char CurrImageFlag = 0;
  OTADataFlashInfo_t p_image_flash;

  SetSysClock( CLK_SOURCE_PLL_60MHz );
  FLASH_ROM_LOCK( 0 );
#if use_eeprom_flag

  EEPROM_READ( OTA_DATAFLASH_ADD, &p_image_flash, 4 );

  /* һִУûи¹ԺºڲDataFlash */

  if ( ( p_image_flash.ImageFlag != ImageFlag_USER_PROGRAM_CALL_IAP ) )
  {
    jumpApp();
  }

#else
  R32_PA_PD_DRV &= ~GPIO_Pin_4;
  R32_PA_PU |= GPIO_Pin_4;
  R32_PA_DIR &= ~GPIO_Pin_4;
  DelayMs( 10 );
  if ( GPIOA_ReadPortPin( GPIO_Pin_4 ) )
  {
    DelayMs( 5 );
    if ( GPIOA_ReadPortPin( GPIO_Pin_4 ) )
    {
      //ǰжǷiap
      jumpApp();
    }
  }
#endif

  pEP0_RAM_Addr = EP0_Databuf;
  pEP1_RAM_Addr = EP1_Databuf;
  pEP2_RAM_Addr = EP2_Databuf;
  pEP3_RAM_Addr = EP3_Databuf;
  USB_DeviceInit();

  while( 1 )
  {
    j++;
    if ( j > 30 )
    {
      j = 0;
      USB_DevTransProcess();
    }
    DelayUs( 20 );
#if use_eeprom_flag
    tcnt++;
    if(tcnt>3000000){
      //1ûвapp
      jumpApp();
    }
#endif
  };
}

void DevEP2_OUT_Deal( UINT8 l )
{ /* ûԶ */
  UINT8 s;

  UINT16 i;
  UINT16 len;
  UINT32 addr, Data;
  switch ( iap_cmd.other.buf[0] )
  {
    case CMD_IAP_PROM :
      if ( iap_cmd.program.len == 0 )
      {
        if ( buf_write_ptr != 0 )
        {
          s = FLASH_ROM_WRITE( flash_write_ptr, ( PUINT32 )buf_write, buf_write_ptr );
          buf_write_ptr = 0;
        }
      }
      else if ( ( iap_cmd.program.len % 4 ) == 0 )    //Ϊ4
      {
//        len = iap_cmd.program.len;
//        addr = ( iap_cmd.program.addr[0] | ( UINT32 ) iap_cmd.program.addr[1] << 8
//                 | ( UINT32 ) iap_cmd.program.addr[2] << 16 | ( UINT32 ) iap_cmd.program.addr[3] << 24 );=ַУ飬˴ʹ
        memcpy( buf_write + buf_write_ptr, iap_cmd.program.buf, iap_cmd.program.len );
        buf_write_ptr += iap_cmd.program.len;
        if ( buf_write_ptr >= 256 )
        {
          s = FLASH_ROM_WRITE( flash_write_ptr, ( PUINT32 )buf_write, 256 );
          flash_write_ptr += 256;
          buf_write_ptr = buf_write_ptr - 256;    //ĳ
          memcpy( buf_write, buf_write + 256, buf_write_ptr );    //ʣµiap_cmd.program.buf + iap_cmd.program.len - buf_write_ptr
        }
      }
      else
      {
        s = 0xfe;
      }
      DevEP2_IN_Deal( s );
      break;
    case CMD_IAP_ERASE :
      s = FLASH_ROM_ERASE( IAP_CODE_START_ADDR, IAP_CODE_END_ADDR - IAP_CODE_START_ADDR );
      buf_write_ptr = 0;    //
      flash_write_ptr = IAP_CODE_START_ADDR;
      DevEP2_IN_Deal( s );
      break;
    case CMD_IAP_VERIFY :

      if ( ( iap_cmd.verify.len % 4 ) == 0 )    //Ϊ4
      {
        memcpy( buf_write, iap_cmd.verify.buf, iap_cmd.verify.len );
        addr = ( iap_cmd.verify.addr[0] | ( UINT32 ) iap_cmd.verify.addr[1] << 8
                 | ( UINT32 ) iap_cmd.verify.addr[2] << 16 | ( UINT32 ) iap_cmd.verify.addr[3] << 24 );
        s = FLASH_ROM_VERIFY( addr, buf_write, iap_cmd.verify.len );
      }
      else
      {
        s = 0xfe;
      }
      DevEP2_IN_Deal( s );
      break;
    case CMD_IAP_END :
      //תapp
      jumpApp();
      break;
    default :
      DevEP2_IN_Deal( 0xfe );
      break;

  }

}

/*******************************************************************************
 * Function Name  : DevEP2_IN_Deal
 * Description    : ˵2ϴ
 * Input          : l: ϴݳ(<64B)
 * Return         : None
 *******************************************************************************/
void DevEP2_IN_Deal( UINT8 s )
{
  EP2_Databuf[64] = s;
  EP2_Databuf[65] = 0;
  R8_UEP2_T_LEN = 2;
  R8_UEP2_CTRL = ( R8_UEP2_CTRL & ~MASK_UEP_T_RES ) | UEP_T_RES_ACK;
}

/*******************************************************************************
 * Function Name  : SwitchImageFlag
 * Description    : лdataflashImageFlag
 * Input          : new_flagлImageFlag
 * Output         : none
 * Return         : none
 *******************************************************************************/
void SwitchImageFlag( UINT8 new_flag )
{
  UINT16 i;
  UINT32 ver_flag;

  /* ȡһ */
  EEPROM_READ( OTA_DATAFLASH_ADD, ( PUINT32 ) &block_buf[0], 256 );

  /* һ */
  EEPROM_ERASE( OTA_DATAFLASH_ADD, EEPROM_PAGE_SIZE );

  /* ImageϢ */
  block_buf[0] = new_flag;

  /* DataFlash */
  EEPROM_WRITE( OTA_DATAFLASH_ADD, ( PUINT32 ) &block_buf[0], 256 );
}
