/*
 * iap.h
 *
 *  Created on: Jul 1, 2021
 *      Author: OWNER
 */

#ifndef SRC_IAP_H_
#define SRC_IAP_H_

#define use_eeprom_flag  1


void SwitchImageFlag(UINT8 new_flag);
/* DataFlashַռλ */
#define OTA_DATAFLASH_ADD               0x00077000-FLASH_ROM_MAX_SIZE

/* DataFlashOTAϢ */
typedef struct
{
    unsigned char ImageFlag;            //¼ĵǰimage־
  unsigned char Revd[3];
}OTADataFlashInfo_t;

#define ImageFlag_USER_PROGRAM_CALL_IAP   0xfe
#define ImageFlag_USER_PROGRAM_CALL_APP   0xff

#define        IAP_CODE_START_ADDR        0x00001000
#define        IAP_CODE_END_ADDR          0x0006C000

#define    jumpApp   ((  void  (*)  ( void ))  ((int*)IAP_CODE_START_ADDR))

#define        CMD_IAP_PROM         0x80
#define        CMD_IAP_ERASE        0x81
#define        CMD_IAP_VERIFY       0x82
#define        CMD_IAP_END          0x83

#define     IAP_LEN            64

typedef union _IAP_CMD
{
    struct
    {
        UINT8    cmd;
        UINT8    len;
        UINT8    addr[4];
    } erase;
    struct
    {
        UINT8    cmd;
        UINT8    len;
        UINT8    status[2];
    } end;
    struct
    {
        UINT8    cmd;
        UINT8    len;
        UINT8    addr[4];
        UINT8    buf[IAP_LEN-6];
    } verify;
    struct
    {
        UINT8    cmd;
        UINT8    len;
        UINT8    addr[4];
        UINT8    buf[IAP_LEN-6];
    } program;
    struct
    {
        UINT8    buf[IAP_LEN];
    } other;
} iap_cmd1;

#endif /* SRC_IAP_H_ */
